/*
 * usart.c
 *
 *  Created on: 2024620
 *      Author: Tyt85
 */

#include "CH58x_common.h"
#include "usart.h"

/*ͨر*/
#define  USART1_RECV_LEN 100                  // յ鳤Ϊ80
uint16_t USART1_RX_STA = 0 ;                //
uint8_t  USART1_RECEIVE_DATA[USART1_RECV_LEN];


void Check_Usart1_Rcv(UINT8V Res);           //ֽڽ
void Usart_scan(void);                       // ַ

//uint8_t StrBuff[USART1_RECV_LEN];//="Now,please enter your words";

uint8_t RxBuff[8];
extern uint8_t StrBuff[];
void Check_Usart1_Rcv(UINT8V Res)
{
    if((USART1_RX_STA&0x8000)==0)//δ
    {
        if(USART1_RX_STA&0x4000)//յ0x0d
        {
            if(Res!=0x0a) USART1_RX_STA=0;//մ¿ʼ
            else USART1_RX_STA|=0x8000; //
        }
        else //ûյ0x0d
        {
              if(Res==0x0d) USART1_RX_STA|=0x4000;
              else
              {
                  USART1_RECEIVE_DATA[USART1_RX_STA&0X3FFF]=Res ;
                  USART1_RX_STA++;
                  if(USART1_RX_STA>(USART1_RECV_LEN-1)) USART1_RX_STA=0;//ݴ¿ʼ
              }
        }
    }
}

void Usart_scan(void)
{
    static uint32_t times = 0;
    uint8_t len = 0 ;

    if(USART1_RX_STA&0x8000)
    {
        len=USART1_RX_STA&0x3fff;//õ˴νյݳ

        if((USART1_RECEIVE_DATA[0] == 0x55)&&(USART1_RECEIVE_DATA[1] == 0x55))
        {
            printf("\r\nThe data you sent is:\r\n\r\n");

            UART1_SendString(&USART1_RECEIVE_DATA[0],len);
            for(uint8_t i = 0;i<USART1_RECV_LEN-1;i++)
                StrBuff[i] = 0 ;
            for(uint8_t i = 0;i<len;i++)
            {
                StrBuff[i]=USART1_RECEIVE_DATA[i+2];
            }

            printf("\r\n\r\n");//뻻
            USART1_RX_STA=0;
        }

    }else
    {
        times++;
        if(times%6000==0)
        {
            printf("\r\nWS2812 Module Test\r\n");
        }
        if(times%1000==0)printf("Please enter data and end with enter key!\r\n");
    }
}


uint8_t trigB;
void DebugInit(void)
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();

    // жϷʽݺͳȥ
    UART1_ByteTrigCfg(UART_7BYTE_TRIG);
    trigB = 7;
    UART1_INTCfg(ENABLE, RB_IER_RECV_RDY | RB_IER_LINE_STAT);
    PFIC_EnableIRQ(UART1_IRQn);

}

/*********************************************************************
 * @fn      UART1_IRQHandler
 *
 * @brief   UART1жϺ
 *
 * @return  none
 */
__INTERRUPT
__HIGH_CODE
void UART1_IRQHandler(void)
{
    volatile uint8_t i;
    static uint8_t words = 0 ;

    switch(UART1_GetITFlag())
    {
        case UART_II_LINE_STAT: // ·״̬
        {
          //  UART1_GetLinSTA();
            uint8_t regVlaue = UART1_GetLinSTA();            //·״̬󣬶regValue ĿǱ档20240625
            break;
        }

        case UART_II_RECV_RDY: // ݴﵽô
            for(i = 0; i != trigB; i++)
            {
                Check_Usart1_Rcv(UART1_RecvByte());
            }
            break;

        case UART_II_RECV_TOUT: // ճʱʱһ֡ݽ
            while( R8_UART1_RFC )
            {
                Check_Usart1_Rcv(R8_UART1_RBR);
            }
            break;

        case UART_II_THR_EMPTY: // ͻգɼ
            break;

        case UART_II_MODEM_CHG: // ִֻ֧0
            break;

        default:
            break;
    }
}
